
program W5100TCP;
{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = xmega192D3, VCC=3.3;


Define_Fuses
  NoteBook   = A;
  COMport    = USB;
  LockBits0 = [];
  FuseBits0  = [];
  FuseBits1  = [];
  FuseBits2  = [];

Import SysTick,TINAstack; //

From System Import Tasks, Processes, LongWord, LongInt; //
From TINAstack Import wzUDP, wzTCP; //

Define

  OSCtype        = int32MHz, PLLmul=4, prescB=1, prescC=1;    // 32Mhz
  SysTick        = 10;             {msec}
  
  StackSize        = $100, iData;
  FrameSize        = $100, iData;

  Scheduler        = iData;
  Taskstack        = 80, iData;
  TaskFrame        = 60;

  TINAdriver    = wiznet;
  TINAtimer    = Timer_D0;
  TINAsockets  = 2;
  TINAport     = SPI_D, PortD,4;

  PortIntF  = 2, PullUp,Falling; //

   Uses uwzTINA;
Implementation

{$EEPROM}

structconst
  dummy            : word                = $1234;
  UDPAknPort       : word                = 38384 ; // 0;
  LocalIP          : tIPaddr             = (192, 168, 2,120);
  Gateway          : tIPaddr             = (192, 168, 2, 1);
  RemPort          : word                = 38384;
  RemHost          : tIPaddr             = (192, 168,2, 100);
  LocPort          : word                = 38383;
  Mask             : tIPaddr             = ($FF, $FF, $FF,  $00);
  MacAddr          : TMacAddr            = ($BA, $A2, $f2, $35, $83, $FA);
  SendRetry        : byte                = 3;
  SendTimeOut      : word                = 2000;
  BoardName        : string[20]          = 'Bitesystem_01';
  DNSServer        : tIPaddr             = (192, 168,2, 1);
  DHCPServer       : tIPaddr             = (192, 168,2, 1);

  SNTP_IP          : tIPaddr             = (192, 168, 1, 103);     //NIST boulder, CO

 {--------------------------------------------------------------}
{ Var Declarations }

{$IDATA}
var

  Buffer           : Array[1..1460] of byte;
  BuffTCP          : Array[1..680] of byte;  //680 Bytes should be enough for the great header of firefox browsers
  UDPBuf           : Array[0..20] of byte;
  TCPTXStr         : String[20];
                                                                            //eigener Buffer
  SNstr            : string[16];
  U1,U2,U3,U4,i    : byte;
  
  RelaisSchalten   : Boolean;
  IPAendern        : boolean;
  IPStr            : string[15];
  IPArray          : tIPaddr;

  SocketUDP,
  SocketTCP,
  SocketClient     : TSocketHandle;

{$IFDEF wzDHCP}
  TempMAC          : TMacAddr;
  TempIP,
  TempGWIP         : tIPaddr;
  UserIP           : tIPaddr;
  sIP              : string[15];
  sMAC             : string[17];
{$ENDIF}

{$IFDEF wzDNS}
  HostName         : string[63];
  SearchIP         : tIPaddr;
{$ENDIF}

{$IFDEF wzSMTP}
  UserPass         : string[60];
  Tmp_auth         : string[60];    // store Base64 encoded Userpass     Rsult ist ca. 25% grer
  Len64            : word;
{$ENDIF}

  CmdStr           : string[30];
  RxTxBuff         : Array[0..50] of byte;
  RxTimer          : SysTimer;
  DoEcho           : boolean;
  ch               : char;
  bb               : byte;
  ww               : word;
  cnt              : word;
  
  Count            : word;
  X                : word;

{ functions }

//-------------------------------------------------------------------------------------------------------------------------

procedure InitPorts;
begin
  DDRA:=  %11111111;   // TFT-Daten 8-15
  DDRB:=  %00000000;   //
  DDRC:=  %11111011;  //  PC2: RX, PC3: TX        TFTDaten 0..7
  DDRD:=  %10111111;  // RS,Wr,CS,Reset  ,D4: SS, D5: Mosi, D6: Miso,D7: Sck  Anbindung zu W5100
  DDRE:=  %10111011;  //PE0: Relais1, PE1: Relais2,  PE2: Daten von CP2104,   PE3: TX-Daten zu CP2104
                      //PE4: SLE-SI4313  PE5: SDI-SI4313 PE6:SDO-SI4313 PE7:Sclk-SI4313
  DDRF:=  %11111011;  // PF0: SEL-3, PF1: SEL-2, PF2: Taster fr IP-Reset
                      // PF3: Relais3 ,PF4: Relais4,PF5: Relais5 ,PF6: Relais6 ,PF7:Relais7
  DDRR:=  %00000000;  // PR0: nc, PR1: 32Mhz-Clk von SI4313

  PortC:= $00;  // Datenbus Lowbyte
  PortA:= $00;  // Datenbus Highbyte
  
  incl(PortF,2); // Taster IP-Reset zu 192.168.2.120

 end InitPorts;
//----------------------------------------------------------------------------------------------------------

procedure  TCPServer;


Var
  len              : word;
  I                : byte;
begin

  case wzGetSocketState(SocketTCP) of
    wzsSockConnected : if wzPacketReceived(SocketTCP) then
                         if len > 0 then
                           len:=  wzReceiveBuffer(SocketTCP);
                           wzResumeReceive(SocketTCP);
                         endif;
                       endif;
                    |
    wzsSockCloseWait : wzDisconnect(SocketTCP);
                    |
    wzsSockClosed,
    wzsSockClosing   : wzInitSocket(SocketTCP);
                    mDelay(1);
                     |
   endcase;
end;



procedure Server0;
Var
  Count            : word;
  X                : word;
begin
    if WzInitOk then
     if wzClientConnected(SocketTCP) then
        Count:= 0;
      if wzPacketReceived(SocketTCP) then
        repeat
          X:= wzReceiveBuffer(SocketTCP);
          Count:= Count + X;
        until (X = 0);
        if Count > 0 then
          wzSendBuffer(SocketTCP, @BuffTCP, Count);
           if ( BuffTCP[1] = $52) and (RelaisSchalten = false) then
                RelaisSchalten:= true;
           endif;  //
           
           if (RelaisSchalten = true) and (BuffTCP[1] <> $52 )then
                 U4:= BuffTCP[1];            // welches Relais ?
                 RelaisSchalten := false;
                              //   Writeln(seroutE0, 'U3:' + Char(U3));
              case U4 of
                  $31: incl(PortE,0);|  // '1'  Relais 1
              endcase;
            endif;
 //.....................................................................................................................................................

           if ( BuffTCP[1] = $49) and (IPAendern = false) then   // $49= 'I'  fr IP-nderung
                IPAendern := true;
                IPStr :='';
           endif;

           if (IPAendern = true) and (BuffTCP[1] <> $49 )then
                 U4:= BuffTCP[1];            //
                   if U4 = $0D then             // CR

                    TCPTXStr:= 'IP_: ';
                    TCPTXStr:= TCPTXStr + IPStr+' ';
                    CopyBlock(@TCPTXStr+1, @RxTxBuff, Word(length(TCPTXStr)));
                    wzSendBuffer(SocketTCP, @RxTxBuff, Word(length(TCPTXStr)));
                    mdelay(10);
                    wzDisconnect(SocketTCP);
                    strtoIP(IPStr,IPArray);
                    LocalIP := IPArray;

                    IPAendern := false;
                    mdelay(20);
                    HardwareReset; //System_reset;
                   endif;
                   
                   IPStr := IPstr + Char(U4);
          endif;
         endif;
      endif;

      if (NOT SocketTCP^.SocketClosed) and (NOT SocketTCP^.PeerTryToDisconnect) then
        wzResumeReceive(SocketTCP);
      endif;
    endif;
  endif;  // ifConnected
  if SocketTCP^.PeerTryToDisconnect then
    wzDisconnect(SocketTCP);
  endif;
  if SocketTCP^.SocketClosed then
      if wzListen(SocketTCP) then
    endif;
  endif;  // if wzInit
end;

{-------------------------------------------------------------------------------}

function Send2Server(count : word; waitReply : boolean) : boolean;
Var
  Err              : boolean;
  w                : word;
begin
  CmdStr:= '';
   if NOT wzConnect(SocketClient) then
      return(false);
  endif;
  if NOT wzSendBuffer(SocketClient, @RxTxBuff, Count) then
      return(false);
  endif;
  if waitReply then
     Count:= 0;
     SetSysTimer(RxTimer, 5000);       // 5 secs timeout
    repeat
      Err:= (SocketClient^.SocketClosed or SocketClient^.PeerTryToDisconnect);
      Err:= Err or isSysTimerZero(RxTimer);
    until wzPacketReceived(SocketClient) or Err;

    if Err then
      wzDisconnect(SocketClient);
      return(false);
    endif;

    repeat
      w:= wzReceiveBuffer(SocketClient);
      Count:= Count + w;
      Err:= (SocketClient^.SocketClosed or SocketClient^.PeerTryToDisconnect);
    until (w = 0) or Err;

    if (NOT Err) and (Count > 0) then
      if Count >= SizeOf(CmdStr) then
        Count:= SizeOf(CmdStr) - 1;
      endif;
      CopyBlock(@RxTxBuff, @CmdStr + 1, Count);
      CmdStr[0]:= char(Count);
    endif;
  endif;

  wzDisconnect(SocketClient);
  return(NOT Err);
end;


procedure PortIntF;             // Interrupt CallBack      fr Taster IP-Reset
begin
 IPStr:= '192.168.002.120';
 strtoIP(IPStr,IPArray);
 LocalIP := IPArray;
 mdelay(10);
 HardwareReset; //System_reset;
 end;

  {--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin

  mdelay(100);
  initports;
  EnableInts($87);

  wzReset;
  wzTina_Stop;
  wzChipmainInit.ResponsePing:= True;
  wzChipmainInit.TimeOut:= 2000;
  wzSetIPAddr(LocalIP, Mask);
  wzSetGateWayAddr(Gateway);
  wzSetHWAddr(MacAddr);
  wzSetTimeOut(SendTimeOut);
  wzSetRetryCount(SendRetry);
  wzChipmainInit.Prio:= TinaPrioMedium;

  SocketUDP:= wzCreateSocket;                // UDP
    With SocketUDP^ do
    Protocol   := protUDP;
    LocalPort  := 38383;
    RemotePort := Remport; //  4023;    // only TCP
    MaxSegSize := 1460;
    RemoteHost := RemHost;
    PacketRecInfo.BufferPtr:= @Buffer;
    PacketRecInfo.BufferLen:= SizeOf(Buffer);
    // Prio:= TinaPrioLow;
  endwith;

  SocketTCP:= wzCreateSocket;         // TCP Server
    With SocketTCP^ do
    Protocol:= protTCP;
    LocalPort:= 38385;  //
    //RemotePort:= 5001;
    RemoteHost:= RemHost;
    MaxSegSize:= 1460;
    DelayAck:= NoDelayedAck; // NoDelayedAck
    PacketRecInfo.BufferPtr:= @BuffTCP;
    PacketRecInfo.BufferLen:= SizeOf(BuffTCP);
  endwith;

  SocketClient:= wzCreateSocket;        // TCP Client
  With SocketClient^ do
    Protocol:= protTCP;
    LocalPort:= 3000;
    RemotePort:= 2500; // 1000 for E-LAB TCP_Checker Server
    RemoteHost:= RemHost;
    MaxSegSize:= 1460;
    PacketRecInfo.BufferPtr:= @RxTxBuff;
    PacketRecInfo.BufferLen:= SizeOf(RxTxBuff);
  endwith;


  if NOT wzTina_Init then
    loop
      mDelay(500);
    endloop;
  endif;

  wzTINASetPriority( TinaPrioVeryHigh);
  wzTINA_Start;
  mDelay(2000);

   ww:= 1;
   DoEcho:= True;
  //  start the server
  // Resume(Server0);

   RelaisSchalten := false;
   IPAendern := false;

loop
   Server0;

endloop;
  

end  W5100TCP.

//------------------------------------------------------------------------------------------------------------------------------------------
